/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ |/ / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * DataModule.java
 *
 * Created on November 15, 2004, 8:42 PM
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: DataModule.java,v 1.1.1.1 2004/12/01 13:55:17 jaquier Exp $
 */

package birg.bluemove.communication.core;

import java.util.Hashtable;
import java.util.Set;

/**
 * Contains all the data needed to set the state of a module. Can have
 * multiple fields (servo1, servo2, led, ...). Should also be used to
 * store sensors values from module (distance, temp, ...).
 *
 * @author  cyril
 */
public class DataModule {

    private String address;
    private Hashtable<String, Integer> data = new Hashtable<String, Integer>();

    /** Creates a new instance of Data */
    public DataModule(String address) {
        this.address = address;
    }

    public DataModule(String address, String field, Integer value) {
        this.address = address;
        setPosition(field, value);
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getAddress() {
        return address;
    }

    public void setPosition(String field, Integer value) {
        data.put(field, value);
    }

    public Integer getPosition(String field) {
        return data.get(field);
    }

    public Hashtable getPositionTable() {
        return data;
    }

    public Set<String> getFields() {
        return data.keySet();
    }
}
