/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * ModuleDataComponent.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: ModuleDataComponent.java,v 1.2 2005/01/25 23:57:20 jaquier Exp $
 */

package birg.bluemove.communication.core;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class is the data representation of a module component.
 * It actually only stores the component name. This class should be
 * extended.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author not attributable
 * @version 1.0
 */
public class ModuleDataComponent {
    private String m_Name = null;

    /**
     * Constructor. Sets the name of the ModuleDataComponent.
     *
     * @param name String
     */
    public ModuleDataComponent(String name) {
        m_Name = name;
    }

    /**
     * Gets the name of the ModuleDataComponent.
     *
     * @return String
     */
    public String getName() {
        return m_Name;
    }

    /**
     * Sets the name of the ModuleDataComponent.
     *
     * @param name String
     */
    public void setName(String name) {
        m_Name = name;
    }
}
