/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * OpenProjectDialog.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: OpenProjectDialog.java,v 1.5 2005/01/27 16:37:09 jaquier Exp $
 */

package birg.bluemove.config.gui;

import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;

import birg.bluemove.config.core.OpenProject;
import org.apache.log4j.Logger;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class displays a file chooser used to open a
 * project.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public class OpenProjectDialog extends JFileChooser {

    static Logger logger = Logger.getLogger(OpenProjectDialog.class);

    protected OpenProject m_openProject = null;

    /**
     * Constructor.
     *
     * @param openProject OpenProject
     */
    public OpenProjectDialog(OpenProject openProject) {
        m_openProject = openProject;
        setDialogTitle("Open project...");
    }

    /**
     * Displays the file chooser and returns the selected file.
     *
     * @param parent Component
     * @return File
     */
    public File showAndGet(Component parent) {
        File file = null;
        int returnVal = showOpenDialog(parent);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            file = getSelectedFile();
            logger.info("Opening: " + file.getName() + ".");
        } else {
            logger.debug("Open command cancelled by user.");
        }
        return file;
    }
}
