/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * PrefsBluemove.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: PrefsBluemove.java,v 1.3 2005/01/27 16:37:09 jaquier Exp $
 */

package birg.bluemove.config.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import birg.bluemove.resources.resources;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class displays a preferences panel for the Bluemove
 * application.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public class PrefsBluemove extends JPanel {

    PrefsGUI m_prefsGui = null;

    /**
     * Constructor.
     *
     * @param prefsGui PrefsGUI
     */
    public PrefsBluemove(PrefsGUI prefsGui) {
        m_prefsGui = prefsGui;
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Initializes the graphical components.
     *
     * @throws Exception
     */
    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jButton1.setText("Cancel");
        jButton1.setMaximumSize(new Dimension(95, 25));
        jButton1.setMinimumSize(new Dimension(95, 25));
        jButton1.setPreferredSize(new Dimension(95, 25));
        jButton1.addActionListener(new PrefsBluemove_jButton1_actionAdapter(this));
        jButton1.setIcon(new ImageIcon(resources.class.getResource(
                "icon_cancel.png")));
        this.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jPanel1.add(jButton1);
    }

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JButton jButton1 = new JButton();

    /**
     * Action performed on the <pre>close</pre> button.
     *
     * @param e ActionEvent
     */
    public void jButton1_actionPerformed(ActionEvent e) {
        m_prefsGui.dispose();
    }
}


class PrefsBluemove_jButton1_actionAdapter implements ActionListener {
    private PrefsBluemove adaptee;
    PrefsBluemove_jButton1_actionAdapter(PrefsBluemove adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}
