/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * PreferencesGUI.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: PrefsGUI.java,v 1.3 2005/01/27 16:37:09 jaquier Exp $
 */

package birg.bluemove.config.gui;

import javax.swing.JDialog;
import javax.swing.JSplitPane;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class displays a preferences dialog. These preferences
 * are user related. There is no project related preferences in this dialog. The
 * settings are stored in the home directory of the user, depending on the
 * operating system.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public class PrefsGUI extends JDialog {

    PrefsTree m_prefsTree = new PrefsTree(this);
    PrefsBluemove m_prefsBluemove = new PrefsBluemove(this);
    PrefsGeneral m_prefsGeneral = new PrefsGeneral(this);
    PrefsPlayer m_prefsPlayer = new PrefsPlayer(this);

    /**
     * Constructor.
     */
    public PrefsGUI() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Initializes the graphical components.
     *
     * @throws Exception
     */
    private void jbInit() throws Exception {
        this.setTitle("Preferences");
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.add(m_prefsBluemove, JSplitPane.RIGHT);
        jSplitPane1.add(m_prefsTree, JSplitPane.LEFT);
        this.getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);
    }

    /**
     * Sets the preferences panel. This panel is on the right of the split pane.
     *
     * @param value Object
     */
    public void setPrefsPanel(Object value) {
        if (!(value instanceof String)) {
            return;
        }
        if (value.equals("General")) {
            jSplitPane1.setRightComponent(m_prefsGeneral);
            m_prefsGeneral.loadSettings(null);
        } else if (value.equals("Bluemove")) {
            jSplitPane1.setRightComponent(m_prefsBluemove);
        } else if (value.equals("Player")) {
            jSplitPane1.setRightComponent(m_prefsPlayer);
            m_prefsPlayer.loadSettings(null);
        }

    }

    JSplitPane jSplitPane1 = new JSplitPane();
}
