/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * SaveProjectDialog.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: SaveProjectDialog.java,v 1.4 2005/01/27 22:03:13 jaquier Exp $
 */

package birg.bluemove.config.gui;

import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;

import birg.bluemove.config.core.SaveProject;
import org.apache.log4j.Logger;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class displays a file chooser used to save a
 * project.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public class SaveProjectDialog extends JFileChooser {
    static Logger logger = Logger.getLogger(OpenProjectDialog.class);

    protected SaveProject m_saveProject = null;

    /**
     * Constructor.
     *
     * @param saveProject SaveProject
     */
    public SaveProjectDialog(SaveProject saveProject) {
        m_saveProject = saveProject;

        setApproveButtonText("Save");
        setDialogTitle("Save project as...");
    }

    /**
     * Displays the file chooser and returns the selected file.
     *
     * @param parent Component
     * @return File
     */
    public File showAndGet(Component parent) {
        File file = null;
        int returnVal = showOpenDialog(parent);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            file = getSelectedFile();
            logger.info("Saving: " + file.getName() + ".");
        } else {
            logger.debug("Save command cancelled by user.");
        }
        return file;
    }
}
