/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * Setting.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: Setting.java,v 1.2 2005/01/27 22:03:13 jaquier Exp $
 */

package birg.bluemove.config.gui;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This is the setting interface. This class should be
 * implemented by all the panel of the user preferences components. It defines
 * basics methods used to load and save the settings.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public interface Setting {
    static final String BUTTON_APPLY = "apply";

    /**
     * Loads the settings into the corresponding JComponent of the panel.
     *
     * @param obj Object
     */
    abstract void loadSettings(Object obj);

    /**
     * Takes the user values and saves them on the user harddisk.
     */
    abstract void saveSettings();
}
