/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * Demo.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id$
 */

package birg.bluemove.main;

import static java.lang.Math.*;

import birg.bluemove.communication.bluetooth.Bluetooth;
import birg.bluemove.communication.core.*;
import org.apache.log4j.*;

public class Demo {

    static Logger logger = Logger.getLogger(Demo.class);

    public Demo() {
        // Perform Bluetooth tests
        DataInterface bluetooth = null;
        try {
            bluetooth = Bluetooth.getInstance();
        } catch (Exception e) {
        }
        ModuleDataManager dataManager = ModuleDataManager.getInstance();

        ModuleData m1 = new ModuleData("424952470001");
        ModuleData m2 = new ModuleData("424952470002");

        ActuatorData s1 = new ActuatorData("Servo1");
        ActuatorData s2 = new ActuatorData("Servo1");

        m1.addComponent(s1);
        m2.addComponent(s2);

        dataManager.addModule(m1);
        dataManager.addModule(m2);

        bluetooth.startConnections(dataManager);

        for (double t = 0.0; t < Math.PI * 60.0; t += 0.01) {
            double position1 = 90.0 * Math.sin(t * 1.2) * Math.cos(2.7 * t);
            //double position2 = 90.0*Math.sin(t)*Math.cos(position1*0.1);
            double position2 = 30.0 *
                               (sin(t) + cos(2.0 * t) + sin(10.0 + t * 3.0));
            //if (position1<0.0) position2=0.0;
            s1.setValue(position1);
            s2.setValue(position2);
            bluetooth.sendData(dataManager);
            // tempo
            try {
                Thread.sleep(5);
            } catch (Exception e) {
            }
        }

        s1.setValue(0.0);
        s2.setValue(0.0);
        bluetooth.sendData(dataManager);
        bluetooth.stopConnections();
    }

    public static void main(String[] args) {
        BasicConfigurator.configure();
        logger.setLevel(Level.OFF);
        Demo demo = new Demo();
    }
}
