/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * Sensor.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: Sensor.java,v 1.5 2005/01/25 23:47:13 jaquier Exp $
 */

package birg.bluemove.module.core;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: This class represents an sensor (ir, shock sensor, ...). It
 * inherits from <pre>ModuleComponent</pre> as the <pre>Actuator</pre> class
 * do. It has a reference to his parent module.</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 * @author Cyril
 * @version 1.0
 */
public class Sensor extends ModuleComponent {

    private static Integer m_counter = 1;

    /**
     * Constructor. The param <pre>module</pre> is the parent module.
     *
     * @param module Module
     * @throws Exception
     */
    public Sensor(Module module) throws Exception {
        this(module, "Sensor" + m_counter);
    }

    /**
     * Constructor. The param <pre>module</pre> is the parent module.
     *
     * @param module Module
     * @throws Exception
     */
    public Sensor(Module module, String name) throws Exception {
        super(module, name);
        m_counter++;
    }
}
