/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * ModuleSetting.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: ModuleSetting.java,v 1.8 2005/01/25 23:46:44 jaquier Exp $
 */

package birg.bluemove.module.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.TitledBorder;

import birg.bluemove.communication.gui.ModulesList;
import birg.bluemove.module.core.Module;
import birg.bluemove.resources.resources;
import birg.bluemove.utils.gui.MessageBox;
import org.apache.log4j.Logger;


/**
 *
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ModuleSetting extends JPanel implements Setting, ActionListener {

    static Logger logger = Logger.getLogger(ModuleSetting.class);

    protected static final String BUTTON_MLIST = "mList";

    ModuleTab m_mTab = null;
    private Module m_module = null;

    JScrollPane jScrollPane1 = new JScrollPane();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel4 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JLabel jLabel1 = new JLabel();
    JTextField jTextField1 = new JTextField();
    JPanel jPanel1 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    JLabel jLabel2 = new JLabel();
    JTextField jTextField2 = new JTextField();
    JButton jButton1 = new JButton();
    FlowLayout flowLayout3 = new FlowLayout();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    TitledBorder titledBorder1 = new TitledBorder("");
    JPanel jPanel5 = new JPanel();
    JLabel jLabel3 = new JLabel();
    FlowLayout flowLayout4 = new FlowLayout();
    JScrollPane jScrollPane2 = new JScrollPane();
    JTextArea jTextArea1 = new JTextArea();
    JButton applyButton = new JButton();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel6 = new JPanel();

    public ModuleSetting(ModuleTab mTab) {
        m_mTab = mTab;
        try {
            jbInit();
        } catch (Exception ex) {
            logger.error(ex.getMessage());
        }
    }

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        applyButton.setText("Apply");
        applyButton.setIcon(new ImageIcon(resources.class.getResource(
                "icon_accept.png")));
        applyButton.setActionCommand(BUTTON_APPLY);
        applyButton.addActionListener(this);
        applyButton.setEnabled(false);
        this.add(jPanel6, java.awt.BorderLayout.SOUTH);
        jPanel6.add(applyButton);
        jPanel2.setLayout(borderLayout2);
        jPanel3.setLayout(gridBagLayout1);
        jPanel4.setLayout(flowLayout1);
        jLabel1.setMaximumSize(new Dimension(90, 15));
        jLabel1.setMinimumSize(new Dimension(90, 15));
        jLabel1.setPreferredSize(new Dimension(90, 15));
        jLabel1.setText("Module name");
        jTextField1.setText("Module name");
        jTextField1.setColumns(12);
        jTextField1.addKeyListener(new ModuleSetting_jTextField1_keyAdapter(this));
        jPanel1.setLayout(flowLayout2);
        flowLayout2.setAlignment(FlowLayout.LEFT);
        jLabel2.setMaximumSize(new Dimension(90, 15));
        jLabel2.setMinimumSize(new Dimension(90, 15));
        jLabel2.setPreferredSize(new Dimension(90, 15));
        jLabel2.setText("Address");
        jTextField2.setText("Address");
        jTextField2.setColumns(12);
        jTextField2.addKeyListener(new ModuleSetting_jTextField2_keyAdapter(this));
        jButton1.setMaximumSize(new Dimension(20, 19));
        jButton1.setMinimumSize(new Dimension(20, 19));
        jButton1.setPreferredSize(new Dimension(20, 19));
        jButton1.setText("...");
        jButton1.setActionCommand(BUTTON_MLIST);
        jButton1.addActionListener(this);
        flowLayout1.setAlignment(FlowLayout.LEFT);
        jScrollPane1.setDoubleBuffered(true);
        jLabel3.setMaximumSize(new Dimension(90, 15));
        jLabel3.setMinimumSize(new Dimension(90, 15));
        jLabel3.setPreferredSize(new Dimension(90, 15));
        jLabel3.setText("Comment");
        jPanel5.setLayout(flowLayout4);
        flowLayout4.setAlignment(FlowLayout.LEFT);
        jTextArea1.setBorder(BorderFactory.createEtchedBorder());
        jTextArea1.setMaximumSize(new Dimension(268, 94));
        jTextArea1.setMinimumSize(new Dimension(268, 94));
        jTextArea1.setText("Comment");
        jTextArea1.setColumns(24);
        jTextArea1.setRows(6);
        jTextArea1.setTabSize(4);
        jTextArea1.addKeyListener(new ModuleSetting_jTextArea1_keyAdapter(this));
        jScrollPane2.setMaximumSize(new Dimension(268, 94));
        jScrollPane2.setMinimumSize(new Dimension(3, 3));
        jScrollPane2.setPreferredSize(new Dimension(268, 94));
        this.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jPanel2);
        jPanel2.add(jPanel3, java.awt.BorderLayout.NORTH);
        jPanel1.add(jLabel2);
        jPanel1.add(jTextField2);
        jPanel1.add(jButton1);
        jPanel4.add(jLabel1);
        jPanel4.add(jTextField1);
        jPanel5.add(jLabel3);
        jPanel5.add(jScrollPane2);
        jScrollPane2.getViewport().add(jTextArea1);
        jPanel3.add(jPanel1, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
        jPanel3.add(jPanel4, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
        jPanel3.add(jPanel5, new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
    }

    public void loadSettings(Object obj) {
        m_module = (Module) obj;
        setModuleValues();
    }

    public void saveSettings() {
        String str = null;

        str = jTextField1.getText();
        try {
            if (!str.equals(m_module.getName())) {
                m_module.setName(str);
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
            String msg = "Unable to create a module with this name. " +
                         "Name already exits.";
            MessageBox mBox = new MessageBox(null,
                                             MessageBox.MessageBoxType.ERROR,
                                             msg);
            mBox.showDialog();
        }

        str = jTextField2.getText();
        if (!str.equals(m_module.getAddress())) {
            m_module.setAddress(str);
        }

        str = jTextArea1.getText();
        if (!str.equals(m_module.getComment())) {
            m_module.setComment(str);
        }
    }

    private void setModuleValues() {
        jTextField1.setText(m_module.getName());
        jTextField2.setText(m_module.getAddress());
        jTextArea1.setText(m_module.getComment());
    }

    public void actionPerformed(ActionEvent e) {
        if (BUTTON_APPLY.equals(e.getActionCommand())) {
            saveSettings();
            m_mTab.moduleTree.refreshTree();
            applyButton.setEnabled(false);
        } else if (BUTTON_MLIST.equals(e.getActionCommand())) {
            ModulesList mList = new ModulesList(this);
            String value = mList.getValue();
            if (value != null) {
                jTextField2.setText(value);
                applyButton.setEnabled(true);
            }
        }
    }

    public void jTextField1_keyTyped(KeyEvent e) {
        applyButton.setEnabled(true);
    }

    public void jTextField2_keyTyped(KeyEvent e) {
        applyButton.setEnabled(true);
    }

    public void jTextArea1_keyTyped(KeyEvent e) {
        applyButton.setEnabled(true);
    }

}


class ModuleSetting_jTextArea1_keyAdapter extends KeyAdapter {
    private ModuleSetting adaptee;
    ModuleSetting_jTextArea1_keyAdapter(ModuleSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextArea1_keyTyped(e);
    }
}


class ModuleSetting_jTextField1_keyAdapter extends KeyAdapter {
    private ModuleSetting adaptee;
    ModuleSetting_jTextField1_keyAdapter(ModuleSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextField1_keyTyped(e);
    }
}


class ModuleSetting_jTextField2_keyAdapter extends KeyAdapter {
    private ModuleSetting adaptee;
    ModuleSetting_jTextField2_keyAdapter(ModuleSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextField2_keyTyped(e);
    }
}
