/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * ProjectSetting.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: ProjectSetting.java,v 1.6 2005/01/13 15:20:59 jaquier Exp $
 */

package birg.bluemove.module.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import birg.bluemove.module.core.ModulesManager;
import birg.bluemove.resources.resources;
import birg.bluemove.utils.gui.GUITools;


public class ProjectSetting extends JPanel implements Setting, ActionListener {

    ModulesManager m_mManager = ModulesManager.getInstance();

    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JLabel jLabel1 = new JLabel();
    JPanel jPanel1 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JTextArea jTextArea1 = new JTextArea();
    JScrollPane jScrollPane1 = new JScrollPane();
    BorderLayout borderLayout2 = new BorderLayout();
    JButton applyButton = new JButton();
    BorderLayout borderLayout3 = new BorderLayout();
    JPanel jPanel6 = new JPanel();

    public ProjectSetting() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void saveSettings() {
        String str = null;

        str = jTextArea1.getText();
        m_mManager.setDescription(str);
    }

    public void loadSettings(Object obj) {
        if (m_mManager.getBuildImage() != null) {
            ImageIcon icon = new ImageIcon(GUITools.resizeImage(m_mManager.
                    getBuildImage(), 260, 195));
            jLabel1.setIcon(icon);
        }
        jTextArea1.setText(m_mManager.getDescription());
    }

    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        applyButton.setText("Apply");
        applyButton.setIcon(new ImageIcon(resources.class.getResource(
                "icon_accept.png")));
        applyButton.setActionCommand(BUTTON_APPLY);
        applyButton.addActionListener(this);
        applyButton.setEnabled(false);
        jTextArea1.addKeyListener(new ProjectSetting_jTextArea1_keyAdapter(this));
        jTextArea1.addFocusListener(new ProjectSetting_jTextArea1_focusAdapter(this));
        jTextArea1.addMouseListener(new ProjectSetting_jTextArea1_mouseAdapter(this));
        this.add(jPanel6, java.awt.BorderLayout.SOUTH);
        jPanel6.add(applyButton);

        jLabel1.setMaximumSize(new Dimension(260, 195));
        jLabel1.setMinimumSize(new Dimension(260, 195));
        jLabel1.setPreferredSize(new Dimension(260, 195));
        jLabel1.setText(null);
        this.setLayout(borderLayout1);
        jPanel1.setLayout(borderLayout2);
        jTextArea1.setDoubleBuffered(true);
        jTextArea1.setText("Project description");
        jTextArea1.setLineWrap(true);
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setBackground(this.getBackground());
        jScrollPane1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 20));
        jScrollPane1.setDoubleBuffered(true);
        this.add(jPanel1, java.awt.BorderLayout.NORTH);
        jScrollPane1.getViewport().add(jTextArea1);
        jPanel1.add(jLabel1, java.awt.BorderLayout.EAST);
        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }

    public void clear() {
        jTextArea1.setText("");
        jLabel1.setIcon(null);
    }

    public void actionPerformed(ActionEvent e) {
        if (BUTTON_APPLY.equals(e.getActionCommand())) {
            saveSettings();
            applyButton.setEnabled(false);
        }
    }

    public void jTextArea1_keyTyped(KeyEvent e) {
        applyButton.setEnabled(true);
    }

    public void jTextArea1_focusGained(FocusEvent e) {
        jTextArea1.setBackground(Color.WHITE);
    }

    public void jTextArea1_focusLost(FocusEvent e) {
        jTextArea1.setBackground(this.getBackground());
    }

    public void jTextArea1_mouseEntered(MouseEvent e) {
        this.setCursor(new Cursor(Cursor.TEXT_CURSOR));
    }

    public void jTextArea1_mouseExited(MouseEvent e) {
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
}


class ProjectSetting_jTextArea1_keyAdapter extends KeyAdapter {
    private ProjectSetting adaptee;
    ProjectSetting_jTextArea1_keyAdapter(ProjectSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextArea1_keyTyped(e);
    }
}


class ProjectSetting_jTextArea1_focusAdapter extends FocusAdapter {
    private ProjectSetting adaptee;
    ProjectSetting_jTextArea1_focusAdapter(ProjectSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void focusGained(FocusEvent e) {
        adaptee.jTextArea1_focusGained(e);
    }

    public void focusLost(FocusEvent e) {
        adaptee.jTextArea1_focusLost(e);
    }
}


class ProjectSetting_jTextArea1_mouseAdapter extends MouseAdapter {
    private ProjectSetting adaptee;
    ProjectSetting_jTextArea1_mouseAdapter(ProjectSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void mouseEntered(MouseEvent e) {
        adaptee.jTextArea1_mouseEntered(e);
    }

    public void mouseExited(MouseEvent e) {
        adaptee.jTextArea1_mouseExited(e);
    }

}
