/*
 *     __   __
 *    / /  / /_ _____ __ _  ___ _  _____
 *   / _ \/ / // / -_)  ' \/ _ \ / / -_)
 *  /_.__/_/\_,_/\__/_/_/_/\___/___/\__/
 *
 * SensorSetting.java
 *
 * See "License.txt" for information on license agreement,
 * usage, redistribution and warranties.
 *
 * $Id: SensorSetting.java,v 1.5 2005/01/25 23:46:44 jaquier Exp $
 */

package birg.bluemove.module.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import birg.bluemove.module.core.Sensor;
import birg.bluemove.resources.resources;
import birg.bluemove.utils.gui.MessageBox;
import org.apache.log4j.Logger;

public class SensorSetting extends JPanel implements Setting, ActionListener {

    static Logger logger = Logger.getLogger(SensorSetting.class);

    ModuleTab m_mTab = null;
    private Sensor m_sensor = null;

    JScrollPane jScrollPane1 = new JScrollPane();
    JPanel jPanel1 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel2 = new JPanel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    JPanel jPanel3 = new JPanel();
    JTextField jTextField1 = new JTextField();
    JLabel jLabel1 = new JLabel();
    SpinnerNumberModel spinModel1 = new SpinnerNumberModel();
    SpinnerNumberModel spinModel2 = new SpinnerNumberModel();
    JButton applyButton = new JButton();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel jPanel6 = new JPanel();

    public SensorSetting(ModuleTab mTab) {
        m_mTab = mTab;
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.setLayout(borderLayout2);
        applyButton.setText("Apply");
        applyButton.setIcon(new ImageIcon(resources.class.getResource(
                "icon_accept.png")));
        applyButton.setActionCommand(BUTTON_APPLY);
        applyButton.addActionListener(this);
        applyButton.setEnabled(false);
        this.add(jPanel6, java.awt.BorderLayout.SOUTH);
        jPanel6.add(applyButton);
        jPanel1.setLayout(borderLayout1);
        jPanel2.setLayout(gridBagLayout1);
        jTextField1.setText("Sensor name");
        jTextField1.setColumns(12);
        jTextField1.addKeyListener(new SensorSetting_jTextField1_keyAdapter(this));
        jLabel1.setPreferredSize(new Dimension(95, 15));
        jLabel1.setToolTipText("");
        jLabel1.setText("Sensor name");
        this.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jPanel1);
        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);
        jPanel3.add(jLabel1);
        jPanel3.add(jTextField1);
        jPanel2.add(jPanel3, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE,
                new Insets(0, 0, 0, 0), 0, 0));
        spinModel1.setStepSize(0.01);
        spinModel1.setValue(0.0);
        spinModel2.setStepSize(0.01);
        spinModel2.setValue(0.0);
    }

    private void setSensorValues() {
        jTextField1.setText(m_sensor.getName());
    }

    public void loadSettings(Object obj) {
        m_sensor = (Sensor) obj;
        setSensorValues();
    }

    public void saveSettings() {
        String str = null;

        str = jTextField1.getText();
        try {
            if (!str.equals(m_sensor.getName())) {
                m_sensor.setName(str);
            }
        } catch (Exception e) {
            logger.error(e.getMessage());
            String msg = "Unable to create a component with this name. " +
                         "Name already exits.";
            MessageBox mBox = new MessageBox(null,
                                             MessageBox.MessageBoxType.ERROR,
                                             msg);
            mBox.showDialog();
        }
    }

    public void jTextField1_keyTyped(KeyEvent e) {
        applyButton.setEnabled(true);
    }

    public void actionPerformed(ActionEvent e) {
        if (BUTTON_APPLY.equals(e.getActionCommand())) {
            saveSettings();
            m_mTab.moduleTree.refreshTree();
            applyButton.setEnabled(false);
        }
    }
}


class SensorSetting_jTextField1_keyAdapter extends KeyAdapter {
    private SensorSetting adaptee;
    SensorSetting_jTextField1_keyAdapter(SensorSetting adaptee) {
        this.adaptee = adaptee;
    }

    public void keyTyped(KeyEvent e) {
        adaptee.jTextField1_keyTyped(e);
    }
}
