package birg.bluemove.timelines.core.timingblock;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author Kevin Drapel
 * @version 1.0
 */
public class LoopBlock extends TimingBlock {
    /**
     * Constructor.
     */
    public LoopBlock() {
        super();
    }

    protected int m_remainingRepetitions = 0;

    /**
     * Resets the block.
     */
    public void reset() {
        m_remainingRepetitions = m_nbRepetitions;
    }

    /**
     * Gets next time value.
     * @param time double
     * @param delta double
     * @return double
     */
    public double getNextTime(double time, double delta) {
        if (m_remainingRepetitions <= 0) {
            return time + delta;
        }

        double t = time + delta;

        if (t > getEndTime()) {
            m_remainingRepetitions--;
            t = getStartTime();
        }
        return t;
    }
}
