package birg.bluemove.timelines.core.timingblock;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author Kevin Drapel
 * @version 1.0
 */
public class PauseBlock extends TimingBlock {

    protected double m_internalCounter = 0.0;
    protected double m_pauseLength = 0.0;

    /**
     * Constructor.
     */
    public PauseBlock() {
        super();
    }

    /**
     * Sets pause length.
     * @param length double
     */
    public void setPauseLength(double length) {
        m_pauseLength = length;
    }

    /**
     * Gets pause length.
     * @return double
     */
    public double getPauseLength() {
        return m_pauseLength;
    }

    /**
     * Resets the block.
     */
    public void reset() {
        m_internalCounter = 0.0;
    }

    public double getNextTime(double time, double delta) {
        m_internalCounter += delta;
        if (m_internalCounter <= m_pauseLength) {
            return time;
        }
        return time + delta;
    }
}
