package birg.bluemove.timelines.core.timingblock;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author Kevin Drapel
 * @version 1.0
 */
public class PingpongBlock extends TimingBlock {
    /**
     * Constructor.
     */
    public PingpongBlock() {
        super();
    }

    protected double m_direction = 1.0;
    protected int m_remainingRepetitions = 0;

    /**
     * Resets the block.
     */
    public void reset() {
        m_remainingRepetitions = m_nbRepetitions * 2;
        m_direction = 1.0;
    }

    /**
     * Gets next time.
     * @param time double
     * @param delta double
     * @return double
     */
    public double getNextTime(double time, double delta) {
        if (m_remainingRepetitions <= 0) {
            return time + delta;
        }

        double t = time + delta * m_direction;

        if (t > getEndTime()) {
            m_direction = -1.0;
            m_remainingRepetitions--;
            t = getEndTime() - Double.MIN_VALUE;
            return t - 0.2;
        }

        if (t <= getStartTime()) {
            m_direction = 1.0;
            m_remainingRepetitions--;
            t = getStartTime();
        }

        return t;
    }


}
