/*
 * testGUI.java
 *
 * Created on 16. novembre 2004, 20:33
 */

package birg.bluemove.timelines.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;

import birg.bluemove.timelines.core.interpolator.*;
import birg.bluemove.timelines.core.interpolator.Key;
import birg.bluemove.utils.V2D;
import org.apache.log4j.Logger;

/**
 *
 * @author  Nom
 */
public class testGUI extends javax.swing.JFrame implements MouseListener,
        MouseMotionListener {

    static Logger logger = Logger.getLogger(testGUI.class);

    java.util.List<Key> keys = new LinkedList<Key>();

    Interpolator linear = new InterpolatorLinear();
    Interpolator bezier = new InterpolatorHermite();

    /** Creates new form testGUI */
    public testGUI() {
        initComponents();
        setSize(640, 480);

//        KeyBezier k1 = new KeyBezier(200.0f, 140.0f);
//        KeyBezier k2 = new KeyBezier(400.0f, 300.0f);
//
//        k1.setTangentOutput(new V2D(200.0f, 150.0f));
//        k2.setTangentInput(new V2D(400.0f, 180.0f));
//
//        keys.add(k1);
//        keys.add(k2);
        addMouseListener(this);
        addMouseMotionListener(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() { //GEN-BEGIN:initComponents

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        pack();
    } //GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new testGUI().setVisible(true);
            }
        });
    }

    // THIS IS ONLY A TEST !
    public void paint(Graphics g) {
        //super.paint(g);
        Graphics2D g2d = (Graphics2D) g;

        Rectangle r = g2d.getClipBounds();
        g2d.setColor(Color.white);
        g2d.fillRect(r.x, r.y, r.width, r.height);

//        KeyBezier k0 = (KeyBezier) keys.get(0);
//        KeyBezier k1 = (KeyBezier) keys.get(1);
//
//        int ptStartX = (int) k0.getFrame();
//        int ptStartY = (int) k0.getValue();
//        int ptEndX = (int) k1.getFrame();
//        int ptEndY = (int) k1.getValue();
//        int ptCtrl1X = (int) k0.getTangentOutput().x;
//        int ptCtrl1Y = (int) k0.getTangentOutput().y;
//        int ptCtrl2X = (int) k1.getTangentInput().x;
//        int ptCtrl2Y = (int) k1.getTangentInput().y;
//
//        g2d.setColor(Color.green);
//        g2d.fillOval(ptStartX - 5, ptStartY - 5, 10, 10);
//        g2d.setColor(Color.red);
//        g2d.fillOval(ptEndX - 5, ptEndY - 5, 10, 10);
//
//        g2d.setColor(Color.blue);
//        g2d.fillOval(ptCtrl1X - 3, ptCtrl1Y - 5, 6, 6);
//        g2d.fillOval(ptCtrl2X - 3, ptCtrl2Y - 3, 6, 6);
//
//        g2d.drawLine(ptStartX, ptStartY, ptCtrl1X, ptCtrl1Y);
//        g2d.drawLine(ptEndX, ptEndY, ptCtrl2X, ptCtrl2Y);
//
//        g2d.setColor(Color.black);
//        float df = k1.getFrame() - k0.getFrame();
//        for (float j = k0.getFrame(); j < k1.getFrame(); j += df / 50.0f) {
//            float yPos = bezier.evaluate(keys, j);
//            g2d.fillOval((int) j - 1, (int) yPos - 1, 2, 2);
//        }
    }


    public void mouseClicked(MouseEvent e) {
        Point p = e.getPoint();
        this.repaint();
    }


    public void mouseMoved(MouseEvent e) {
        Point p = e.getPoint();
        this.repaint();
    }

    /**
     * Unused events
     */

    //boolean bDrag=false;

    public void mouseDragged(MouseEvent e) {
        //if (!bDrag) bDrag=true;
        if (selected == 0) {
//            KeyBezier k0 = (KeyBezier) keys.get(0);

//            k0.setTangentOutput(new V2D(e.getPoint().x, e.getPoint().y));
            this.repaint();
            return;
        }

        if (selected == 1) {
//            KeyBezier k0 = (KeyBezier) keys.get(1);

//            k0.setTangentInput(new V2D(e.getPoint().x, e.getPoint().y));
            this.repaint();
            return;
        }
    }


    public double distanceToV2D(Point p, V2D v) {
        return (float) Math.sqrt((p.x - v.x) * (p.x - v.x) +
                                 (p.y - v.y) * (p.y - v.y));
    }

    int selected = -1;

    public void mousePressed(MouseEvent e) {
        Point p = e.getPoint();
//
//        KeyBezier k0 = (KeyBezier) keys.get(0);
//        KeyBezier k1 = (KeyBezier) keys.get(1);

//        selected = -1;
//        if (distanceToV2D(p, k0.getTangentOutput()) < 5) {
//            selected = 0;
//        }
//        if (distanceToV2D(p, k1.getTangentInput()) < 5) {
//            selected = 1;
//        }

    }

    public void mouseReleased(MouseEvent e) {
        selected = -1;
    }

    public void mouseOutside(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
