package birg.bluemove.timelines.gui.timelinestree.nodes;

import java.awt.*;
import java.awt.event.MouseEvent;

import birg.bluemove.module.core.ModuleComponent;
import birg.bluemove.utils.gui.GUITools;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class SensorTimelineNode extends ModuleComponentTimelineNode {

    Color m_colorIsActive = new Color(0.90f, 1.0f, 0.9f);
    Color m_colorIsInactive = new Color(1.0f, 0.90f, 0.6f);

    /**
     * Constructor.
     * @param moduleComponent ModuleComponent
     */
    public SensorTimelineNode(ModuleComponent moduleComponent) {
        super(moduleComponent);

    }

    /**
     * Paints the border.
     * @param g Graphics
     */
    public void paintBorder(Graphics g) {
        //super.paintBorder(g);
        Graphics2D g2d = (Graphics2D) g.create();
        Rectangle bounds = new Rectangle(0, 0, getWidth(), getHeight());
        g2d.setColor(Color.BLACK);
        g2d.drawRect(bounds.x, bounds.y, bounds.width - 1, bounds.height);
        g2d.dispose();
    }

    /**
     * Paints the component.
     * @param g Graphics
     */
    public void paintComponent(Graphics g) {
        //super.paintComponent(g);

        Graphics2D g2d = (Graphics2D) g.create();
        g2d.setRenderingHints(GUITools.getBestQualityHints());

        GradientPaint gradient;

        gradient = new GradientPaint(0, 0, m_colorIsInactive,
                                     getWidth(), 0,
                                     Color.WHITE,
                                     false);

        g2d.setPaint(gradient);
        Rectangle bounds = new Rectangle(0, 0, getWidth(), getHeight());
        int hg = getClosedHeight();
        g2d.fillRect(bounds.x, bounds.y, bounds.width, hg / 2);

        if (!isExpanded()) {
            return;
        }

        g2d.setColor(Color.BLACK);
        g2d.drawLine(bounds.x, hg, bounds.x + bounds.width, hg);

        Rectangle lowerRect = new Rectangle(bounds.x, hg + 1, bounds.width,
                                            bounds.height - hg - 1);
        g2d.setColor(Color.WHITE);
        g2d.fillRect(lowerRect.x, lowerRect.y, lowerRect.width,
                     lowerRect.height);

        g2d.dispose();
    }

    public void mouseDragged(MouseEvent e) {
    }

    public void mouseMoved(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }


}
