package birg.bluemove.utils.gui;

import java.awt.Font;
import java.awt.FontMetrics;

import javax.swing.JLabel;
import javax.swing.UIManager;

/**
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author Kevin Drapel
 * @version $Id: FontTools.java,v 1.5 2005/01/26 22:41:43 drapel Exp $
 */
public class FontTools {

    static protected JLabel dummyLabel = new JLabel("");
    static protected Font m_controlFontBold = null;
    static protected Font m_controlFontItalic = null;

    /**
     * Returns a label font
     * @return Font
     */
    public static Font getControlFont() {
        return UIManager.getFont("Label.font");
    }

    /**
     * Returns a bold font
     * @return Font
     */
    public static Font getControlFontBold() {
        if (m_controlFontBold == null) {
            m_controlFontBold = getControlFont().deriveFont(Font.BOLD);
        }
        return m_controlFontBold;
    }

    /**
     * Returns an italic font
     * @return Font
     */
    public static Font getControlFontItalic() {
        if (m_controlFontItalic == null) {
            m_controlFontItalic = getControlFont().deriveFont(Font.ITALIC);
        }
        return m_controlFontItalic;
    }

    /**
     * Returns the maximum height of a font
     * @param font Font
     * @return int
     */
    public static int getMaxHeight(Font font) {
        FontMetrics fm = dummyLabel.getFontMetrics(font);
        return fm.getAscent() - fm.getDescent();
    }

}
