/*
 *                                                       __
 *   ____ _____    _________.__._______   ____   _______/  |_  ____
 * _/ __ \\__. \  /  ___<   |  |\_  __ \_/ __ \ /  ___/\   __\/  _ \
 * \  ___/ / __ \_\___ \ \___  | |  | \/\  ___/ \___ \  |  | (  <_> )
 *  \___  >____  /____  >/ ____| |__|    \___  >____  > |__|  \____/
 *	\/     \/     \/ \/                  \/     \/
 *
 *                          d z o d z e t s
 *                              l a b s
 *
 */

package birg.bluemove.utils.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.MouseEvent;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.*;

import birg.bluemove.resources.resources;


/**
 *
 * <p>Title: Bluemove</p>
 *
 * <p>Description: Modular Robot Project</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: BIRG</p>
 *
 * @author Kevin Drapel
 * @version $Id: SplashScreen.java,v 1.3 2005/01/26 22:41:43 drapel Exp $
 */
public class SplashScreen extends JDialog {
    // display length in milliseconds
    static final int TIMEOUT = 2500;

    BorderLayout borderLayout1 = new BorderLayout();
    ImageIcon img;

    JLabel label = new JLabel();
    GridLayout gridLayout1 = new GridLayout();
    Timer timer;
    JDialog jd;

    /**
     * Constructor.
     */
    public SplashScreen() {
        try {
            jd = this;
            img = new ImageIcon(resources.class.getResource(
                    "splashscreen.png"));
            jbInit();
            this.setAlwaysOnTop(true);
            this.setBounds(0, 0, img.getIconWidth(), img.getIconHeight());
            timer = new Timer();
            timer.schedule(task, TIMEOUT);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * Task called when timer is elapsed.
     */
    TimerTask task = new TimerTask() {
        public void run() {
            jd.dispose();
        }
    };

    /**
     * Inits the splashscreen.
     * @throws Exception
     */
    private void jbInit() throws Exception {
        label.setIcon(img);
        label.addMouseListener(new SplashScreen_jLabel2_mouseAdapter(this));
        this.setLocale(java.util.Locale.getDefault());
        this.setJMenuBar(null);
        this.setModal(true);
        this.setResizable(false);
        this.setUndecorated(true);
        this.getContentPane().setLayout(gridLayout1);
        this.getContentPane().add(label, null);
    }


    /**
     * Handles mouse event when user clicks on the splashscreen.
     * @param e MouseEvent
     */
    void jLabel2_mousePressed(MouseEvent e) {
        this.dispose();
    }

}


/***
 * Adapter class
 */

class SplashScreen_jLabel2_mouseAdapter extends java.awt.event.MouseAdapter {
    SplashScreen adaptee;

    SplashScreen_jLabel2_mouseAdapter(SplashScreen adaptee) {
        this.adaptee = adaptee;
    }

    public void mousePressed(MouseEvent e) {
        adaptee.jLabel2_mousePressed(e);
    }
}
